//=======================================================
//  Device under test
//=======================================================
// --- a counter ---

module counter (
    input clock,
    input reset,
    output reg [31:0] count
);
// DUT_state is only used as an example state variable 
reg [3:0] DUT_state  /* synthesis preserve */;
//
always @(posedge clock) begin
    if (reset) begin
        count <= 32'd0;
        DUT_state <= 4'd0;
    end
	else if (DUT_state==4'd0) begin
		count <= count + 32'd1 ;
		DUT_state <= 4'd1;
	end
	else if (DUT_state==4'd1) begin
		count <= count + 32'd1 ;
		DUT_state <= 4'd2;
	end
    else begin
        count <= count + 32'd1 ;
		DUT_state <= 4'd0;
    end
end
endmodule